Schema: AtsDegrossRevConResult (ID: 2356)
Published by the dedicated degrossing execution engine at three lifecycle stages:
1. Received - on order arrival, confirms receipt, auction fields blank/zero
2. Provisional - each minute, trial match results showing what would happen now
3. Final - after auction completes and exchange confirms fills
See DEGROSSING_PLAN_2.1.md section 5.3 and 11.1 for specification.
METADATA
| Attribute | Value |
|---|---|
| Topic | 2270-execution-engine |
| MLink Token | ClientTrading |
| MLink Endpoint | MLink-Live |
| SRSE Product | SRTrade |
Note: The symbol
=next to a field number indicates that it is a primary key.
BODY
| # | Field | Type | Default Value | Comment |
|---|---|---|---|---|
| 10= | ticker | TickerKey | underlier ticker | |
| 11= | expiry | DateKey | flex option expiry date | |
| 12= | accnt | string(16) | SR trading account | |
| 13= | side | enum : BuySell | Buy = reversal (lend); Sell = conversion (borrow) | |
| 14= | clientFirm | string(16) | ||
| 15= | auctionDttm | DateTime | auction cycle timestamp (identifies which specific auction; multiple per day) | |
| 100 | resultStatus | enum : AtsDegrossResultStatus | ||
| 101 | parentNumber | long | parent order reference | |
| 110 | submittedSize | int | original order size | |
| 111 | useSRRate | enum : YesNo | echo: did client use SR rate? | |
| 112 | useSRSDiv | enum : YesNo | echo: did client use SR sdiv? | |
| 113 | useSRDDiv | enum : YesNo | echo: did client use SR ddiv schedule? | |
| 114 | effectiveRate | double | rate actually used (SR or client-supplied) | |
| 115 | effectiveSDiv | double | sdiv actually used (SR or client-supplied) | |
| 120 | refUPrc | double | reference underlier price used | |
| 121 | strike | double | SR-chosen strike | |
| 122 | iDays | int | interest days to expiry | |
| 130 | limitPrice | double | computed limit price for this order | |
| 140 | clearingPrice | double | single clearing price for this (ticker, expiry) | |
| 141 | srClearingSDiv | double | clearing SDIV using SR rate + SR ddiv | |
| 142 | clientClearingSDiv | double | clearing SDIV using client rate + client ddiv | |
| 143 | matchSize | int | matched size (provisional or confirmed) | |
| 144 | matchStatus | enum : AtsRevConFillStatus | ||
| 145 | withdrawReason | text1 | reserved; reason an order was withdrawn (unused in 2.1) | |
| 160 | fillSize | int | exchange-confirmed fill size | |
| 161 | numCrosses | int | number of bilateral crosses this order participated in | |
| 170 | timestamp | DateTime | ||
| 175 | eventNum | int | which event produced this row: 0 = provisional heartbeat (~60s), 1/2 = trial #, 3 = binding final |
Get Schema API Call
- Python
- cUrl
import requests
# Replace with your desired MLINK URL
MLINK_PROD_URL = 'https://mlink-live.nms.saturn.spiderrockconnect.com/rest/json'
# Replace with your MLINK API Key
API_KEY = 'XXXX-XXXX-XXXX-XXXX'
# Replace with your desired MsgType.
MSG_TYPE = 'AtsDegrossRevConResult'
# Request Parameters for Get Schema Of The MsgType
params = {
# Required Parameters
"apiKey": API_KEY,
"cmd": 'getschema',
"msgType": MSG_TYPE,
}
response = requests.get(MLINK_PROD_URL, params=params)
curl -G 'https://mlink-live.nms.saturn.spiderrockconnect.com/rest/json' \
--data-urlencode 'apiKey=XXXX-XXXX-XXXX-XXXX' \
--data-urlencode 'cmd=getschema' \
--data-urlencode 'msgType=AtsDegrossRevConResult'
Get Msg API Call
- Python
- cUrl
import requests
# Replace with your desired MLINK URL
MLINK_PROD_URL = 'https://mlink-live.nms.saturn.spiderrockconnect.com/rest/json'
# Replace with your MLINK API Key
API_KEY = 'XXXX-XXXX-XXXX-XXXX'
# Replace with your desired MsgType.
MSG_TYPE = 'AtsDegrossRevConResult'
# Replace with your pkey value for getting the specific message desired
PKEY = 'ReplaceThisValueForTheQueryToWork'
# Replace with your desired view. A "|" separated list of views can be provided
# If no view is provided, all views will be returned.
VIEW = 'resultStatus|parentNumber|submittedSize|useSRRate|useSRSDiv|useSRDDiv|effectiveRate|effectiveSDiv|refUPrc|strike|iDays|limitPrice|clearingPrice|srClearingSDiv|clientClearingSDiv|matchSize|matchStatus|withdrawReason|fillSize|numCrosses|timestamp|eventNum'
# Replace with your desired where clause.
# a string in the form "field1:eq:valuse" or "(field1:ne:value1 & field1:ne:value2)
# "WHERE" clauses can contain the following comparison symbols:
# :gt: is greater than
# :ge: is greater than or equal to
# :lt: is less than
# :le: is less than or equal to
# :eq: is equal
# :ne: is not equal
# %26 is an AND statement
# | is an OR statement
# :sw: is starts with
# :ew: is ends with
# :cv: is contains values
# :nv: is does not contain value
# :cb: is contained between (two dates for instance) separated by '$'
WHERE = 'accnt:eq:ExampleString'
# Request Parameters for getmsg Of The MsgType
params = {
# Required Parameters
"apiKey": API_KEY,
"cmd": 'getmsg',
"pkey": PKEY,
"msgType": MSG_TYPE,
# Optional Parameters
"view": VIEW,
"where": WHERE
}
response = requests.get(MLINK_PROD_URL, params=params)
curl -G 'https://mlink-live.nms.saturn.spiderrockconnect.com/rest/json' \
--data-urlencode 'apiKey=XXXX-XXXX-XXXX-XXXX' \
--data-urlencode 'cmd=getmsg' \
--data-urlencode 'pkey=ReplaceThisValueForTheQueryToWork' \
--data-urlencode 'msgType=AtsDegrossRevConResult' \
--data-urlencode 'view=resultStatus|parentNumber|submittedSize|useSRRate|useSRSDiv|useSRDDiv|effectiveRate|effectiveSDiv|refUPrc|strike|iDays|limitPrice|clearingPrice|srClearingSDiv|clientClearingSDiv|matchSize|matchStatus|withdrawReason|fillSize|numCrosses|timestamp|eventNum' \
--data-urlencode 'where=accnt:eq:ExampleString'
Get Msgs API Call
- Python
- cUrl
import requests
# Replace with your desired MLINK URL
MLINK_PROD_URL = 'https://mlink-live.nms.saturn.spiderrockconnect.com/rest/json'
# Replace with your MLINK API Key
API_KEY = 'XXXX-XXXX-XXXX-XXXX'
# Replace with your desired MsgType.
MSG_TYPE = 'AtsDegrossRevConResult'
# Replace with your desired view. A "|" separated list of views can be provided
# If no view is provided, all views will be returned
VIEW = 'resultStatus|parentNumber|submittedSize|useSRRate|useSRSDiv|useSRDDiv|effectiveRate|effectiveSDiv|refUPrc|strike|iDays|limitPrice|clearingPrice|srClearingSDiv|clientClearingSDiv|matchSize|matchStatus|withdrawReason|fillSize|numCrosses|timestamp|eventNum'
# Replace with your desired where clause.
# a string in the form "field1:eq:value" or "(field1:ne:value1 & field1:ne:value2)
# "WHERE" clauses can contain the following comparison symbols:
# :gt: is greater than
# :ge: is greater than or equal to
# :lt: is less than
# :le: is less than or equal to
# :eq: is equal
# :ne: is not equal
# %26 is an AND statement
# | is an OR statement
# :sw: is starts with
# :ew: is ends with
# :cv: is contains values
# :nv: is does not contain value
# :cb: is contained between (two dates for instance) separated by '$'
WHERE = 'accnt:eq:ExampleString'
# Replace with your desired limit of how many messages you receive. The default limit is 500
LIMIT = 500
# Order clause eg. "(field1:DESC | field1:ASC | field2:DESC:ABS | field2:ASC:ABS" (default is unordered; default is faster)
ORDER = 'resultStatus:ASC'
# Request Parameters for getmsgs Of The MsgType
params = {
# Required Parameters
"apiKey": API_KEY,
"cmd": 'getmsgs',
"msgType": MSG_TYPE,
# Optional Parameters
"view": VIEW,
"where": WHERE,
"limit": LIMIT,
"order": ORDER
}
response = requests.get(MLINK_PROD_URL, params=params)
curl -G 'https://mlink-live.nms.saturn.spiderrockconnect.com/rest/json' \
--data-urlencode 'apiKey=XXXX-XXXX-XXXX-XXXX' \
--data-urlencode 'cmd=getmsgs' \
--data-urlencode 'msgType=AtsDegrossRevConResult' \
--data-urlencode 'view=resultStatus|parentNumber|submittedSize|useSRRate|useSRSDiv|useSRDDiv|effectiveRate|effectiveSDiv|refUPrc|strike|iDays|limitPrice|clearingPrice|srClearingSDiv|clientClearingSDiv|matchSize|matchStatus|withdrawReason|fillSize|numCrosses|timestamp|eventNum' \
--data-urlencode 'where=accnt:eq:ExampleString' \
--data-urlencode 'limit=500' \
--data-urlencode 'order=resultStatus:ASC'
Get Aggregate API Call
- Python
- cUrl
import requests
# Replace with your desired MLINK URL
MLINK_PROD_URL = 'https://mlink-live.nms.saturn.spiderrockconnect.com/rest/json'
# Replace with your MLINK API Key
API_KEY = 'XXXX-XXXX-XXXX-XXXX'
# Replace with your desired MsgType.
MSG_TYPE = 'AtsDegrossRevConResult'
# Replace with fields you want to see aggregate values for. A "|" separated list of measures should be provided
MEASURE = 'resultStatus|parentNumber|submittedSize|useSRRate|useSRSDiv|useSRDDiv|effectiveRate|effectiveSDiv|refUPrc|strike|iDays|limitPrice|clearingPrice|srClearingSDiv|clientClearingSDiv|matchSize|matchStatus|withdrawReason|fillSize|numCrosses|timestamp|eventNum'
# Replace with fields you want to see aggregated. A "|" separated list of fields should be provided
GROUP = 'resultStatus|useSRRate|useSRSDiv|useSRDDiv|matchStatus'
# Replace with your desired where clause.
# a string in the form "field1:eq:value" or "(field1:ne:value1 & field1:ne:value2)
# "WHERE" clauses can contain the following comparison symbols:
# :gt: is greater than
# :ge: is greater than or equal to
# :lt: is less than
# :le: is less than or equal to
# :eq: is equal
# :ne: is not equal
# %26 is an AND statement
# | is an OR statement
# :sw: is starts with
# :ew: is ends with
# :cv: is contains values
# :nv: is does not contain value
# :cb: is contained between (two dates for instance) separated by '$'
WHERE = 'accnt:eq:ExampleString'
# Request Parameters for getaggregate Of The MsgType
params = {
# Required Parameters
"apiKey": API_KEY,
"cmd": 'getaggregate',
"msgType": MSG_TYPE,
"measure": MEASURE,
"group": GROUP,
# Optional Parameters
"where": WHERE,
}
response = requests.get(MLINK_PROD_URL, params=params)
curl -G 'https://mlink-live.nms.saturn.spiderrockconnect.com/rest/json' \
--data-urlencode 'apiKey=XXXX-XXXX-XXXX-XXXX' \
--data-urlencode 'cmd=getaggregate' \
--data-urlencode 'msgType=AtsDegrossRevConResult' \
--data-urlencode 'measure=resultStatus|parentNumber|submittedSize|useSRRate|useSRSDiv|useSRDDiv|effectiveRate|effectiveSDiv|refUPrc|strike|iDays|limitPrice|clearingPrice|srClearingSDiv|clientClearingSDiv|matchSize|matchStatus|withdrawReason|fillSize|numCrosses|timestamp|eventNum' \
--data-urlencode 'group=resultStatus|useSRRate|useSRSDiv|useSRDDiv|matchStatus' \
--data-urlencode 'where=accnt:eq:ExampleString'
Get Count API Call
- Python
- cUrl
import requests
# Replace with your desired MLINK URL
MLINK_PROD_URL = 'https://mlink-live.nms.saturn.spiderrockconnect.com/rest/json'
# Replace with your MLINK API Key
API_KEY = 'XXXX-XXXX-XXXX-XXXX'
# Replace with your desired MsgType.
MSG_TYPE = 'AtsDegrossRevConResult'
# Replace with your desired where clause.
# a string in the form "field1:eq:value" or "(field1:ne:value1 & field1:ne:value2)
# "WHERE" clauses can contain the following comparison symbols:
# :gt: is greater than
# :ge: is greater than or equal to
# :lt: is less than
# :le: is less than or equal to
# :eq: is equal
# :ne: is not equal
# %26 is an AND statement
# | is an OR statement
# :sw: is starts with
# :ew: is ends with
# :cv: is contains values
# :nv: is does not contain value
# :cb: is contained between (two dates for instance) separated by '$'
WHERE = 'accnt:eq:ExampleString'
# Request Parameters for getCount Of The MsgType
params = {
# Required Parameters
"apiKey": API_KEY,
"cmd": 'getcount',
"msgType": MSG_TYPE,
# Optional Parameters
"where": WHERE,
}
response = requests.get(MLINK_PROD_URL, params=params)
curl -G 'https://mlink-live.nms.saturn.spiderrockconnect.com/rest/json' \
--data-urlencode 'apiKey=XXXX-XXXX-XXXX-XXXX' \
--data-urlencode 'cmd=getcount' \
--data-urlencode 'msgType=AtsDegrossRevConResult' \
--data-urlencode 'where=accnt:eq:ExampleString'